--parse best m3u8 RESOLUTION
if #arg < 1 then return nil end

json = require "json"

local _url = arg[1]
local Curl = nil
local ret = {}

function getdata(Url)
	if Url == nil then return nil end
	if Curl == nil then
		Curl = curl.new()
	end
	local ret, data = Curl:download{ url=Url, A="Mozilla/5.0",connectTimeout=5,maxRedirs=5,followRedir=true}
	if ret == CURL.OK then
		return data
	else
		return nil
	end
end
function tounicode(c)
	if c > 8200 then
		return " "
	end

	if c > 383 then
		c=c-256
		return "\xC6" .. string.format('%c', c)
	elseif c > 319 then
		c=c-192
		return "\xC5" .. string.format('%c', c)
	elseif c > 254 then
		c=c-128
		return "\xC4" .. string.format('%c', c)
	elseif c > 191 then
		c=c-64
		return "\xC3" .. string.format('%c', c)
	else
		return string.format('%c', c)
	end
end

function convHTMLentities(summary)
	if summary ~= nil then
		summary = summary:gsub("&#([0-9]+);",function(c) return tounicode(tonumber(c)) end)
		summary = summary:gsub("&#x([%x]+);",function(c) return tounicode(tonumber(c, 16)) end)
	end
	return summary
end

function getVideoUrl(name)
	local urldata = "https://chaturbate.com/" .. name
	local data = getdata(urldata)
	if data == nil then return -1 end
	
	local m3u8 = nil
	local ma,mb = data:find("m3u8")
	if mb then
		local test = data:sub(mb-300,mb)
		local _,ms = (test:reverse()):find("sptth")
		test = data:sub(mb-ms+1,mb)
		m3u8_url = test:match("(https.-m3u8)")
	end
	if m3u8_url == nil then return -1 end

	m3u8_url = m3u8_url:gsub('\\u002D','-')

	data = convHTMLentities(data)
	local Age = data:match('>Age:</div>.->(%d+)</div>')
	local Real_Name =data:match('>Real Name.</div>.->([%w%s%,%.%d]+)</div>')
	local Location = data:match('>Location:</div>.->(.-)</div>')
	local Languages = data:match('>Language.s.:</div>.->([ñ%w%s%,%.%d]+)</div>')
	local Interested = data:match('>Interested%s+In:</div>.->([%w%s%,%.%d]+)</div>')


	if Real_Name == nil then Real_Name = "" end
	if Age then Real_Name = Real_Name .. "  " .. Age end
	if Location  then 	Real_Name = Real_Name .. " (" .. Location  .. ")"  end
	if Languages  then 	Real_Name = Real_Name .. "  Lan:" .. Languages end
	if Interested  then 	Real_Name = Real_Name .. "  Interested:" .. Interested  end

	if #Real_Name < 2 then Real_Name = nil end
	if Real_Name then
		Real_Name=Real_Name:gsub("[\r\n]+","")
		Real_Name=Real_Name:gsub("^%s+","")
	end

	local res = 0
	local count = 0
	local data = getdata(m3u8_url)
	if data then
		local host = m3u8_url:match('([%a]+[:]?//[_%w%-%.]+)/')
		local lastpos = (m3u8_url:reverse()):find("/")
		local hosttmp = m3u8_url:sub(1,#m3u8_url-lastpos)
		if hosttmp then
			host = hosttmp .."/"
		end
		for band, res1, res2, url in data:gmatch('BANDWIDTH=(%d+).-RESOLUTION=(%d+)x(%d+).-\n(.-)\n') do
			if url and res1 then
				local nr = tonumber(res1)
				if nr < 4000 and nr > res then
					res=nr
					if host and url:sub(1,4) ~= "http" then
						url = host .. url
					end
					entry = {}
					entry['url']  = url
					entry['band'] = band
					entry['res1'] = res1
					entry['res2'] = res2
					entry['name'] = Real_Name or " RESOLUTION=" .. res1 .. "x" .. res2
					count = count + 1
					ret[count] = {}
					ret[count] = entry
				end
			end
		end
	else
		return -1 --url is offline
	end
	return res
end

local have_url = getVideoUrl(_url)
if have_url > 0 then
	return json:encode(ret)
end

return 0  --url is offline
